`include "define.v"
module DelayStage(DIN, ChDelay, CLK, DOUT);
    input [`DEL_DATA_WIDTH - 1:0] DIN;
    input [1:0] 					ChDelay;
    input CLK;
    output [`DEL_DATA_WIDTH - 1:0] DOUT;

reg [`DEL_DATA_WIDTH - 1:0] DOUT, D1,D2,D3;

always@(posedge CLK) begin
 D1 <= DIN;
 D2 <= D1;
 D3 <= D2;
 case(ChDelay) 
   2'd0: DOUT <= DIN;
	2'd1: DOUT <= D1;
	2'd2: DOUT <= D2;
   2'd3: DOUT <= D3;
 endcase 
end
endmodule
